package it.micegroup.gestioneferie.pianificazioneferie.entity;

import java.io.Serializable;

import javax.validation.constraints.NotNull;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import java.util.Collection;
import java.util.ArrayList;
import javax.persistence.OneToMany;
import javax.persistence.CascadeType;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import lombok.ToString;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.Getter;
import lombok.AllArgsConstructor;

import javax.persistence.Table;

import org.apache.commons.lang3.StringUtils;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.Hibernate;
import java.util.Objects;

import it.micegroup.gestioneferie.libs.entity.BaseEntity;
import it.micegroup.voila2runtime.utils.EntityUtils;

@NoArgsConstructor

@Getter
@Setter
@Entity
@Table(name = "D_STATI_ADESIONE_PF")
public class DstatiAdesionePf extends BaseEntity implements Serializable {

	// Generated SERIAL VERSION UID
	private static final long serialVersionUID = 3917817229L;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DstatiAdesionePf.class);

	// ATTRIBUTES
	@NotNull

	@Column(name = "SEQU_ID_STATO_ADESIONE_PF", columnDefinition = "NUMBER(15)")
	private Long sequIdStatoAdesionePf;
	@NotNull

	@Column(name = "CODI_STAT_ADESIONE", columnDefinition = "VARCHAR(50)")
	private String codiStatoAdesione;
	@NotNull

	@Column(name = "DESC_STATO_ADESIONE", columnDefinition = "VARCHAR(250)")
	private String descStatoAdesione;
	@NotNull

	@Column(name = "FLAG_ELIMINATO", columnDefinition = "VARCHAR(1)")
	private String flagEliminato;
	@NotNull

	@Column(name = "UTENTE_ULTIMA_MODIFICA", columnDefinition = "VARCHAR(50)")
	private String utenteUltimaModifica;
	@NotNull

	@Column(name = "DATA_ULTIMA_MODIFICA", columnDefinition = "DATE")
	private Date dataUltimaModifica;
	@NotNull

	@Column(name = "DATA_INIZIO_RECORD", columnDefinition = "DATE")
	private Date dataInizioRecord;
	@NotNull

	@Column(name = "DATA_FINE_RECORD", columnDefinition = "DATE")
	private Date dataFineRecord;

	// IMPORTED PARENTS

	// CONSTRUCTORS
	public DstatiAdesionePf(String objectKey) {
		super();
		setObjectKey(objectKey);
	}

	public DstatiAdesionePf(DstatiAdesionePfKey dstatiAdesionePfKey, Long sequIdStatoAdesionePf,
			String codiStatoAdesione, String descStatoAdesione, String flagEliminato, String utenteUltimaModifica,
			Date dataUltimaModifica, Date dataInizioRecord, Date dataFineRecord) {
		super();

		this.dstatiAdesionePfKey = dstatiAdesionePfKey;

		this.sequIdStatoAdesionePf = sequIdStatoAdesionePf;
		this.codiStatoAdesione = codiStatoAdesione;
		this.descStatoAdesione = descStatoAdesione;
		this.flagEliminato = flagEliminato;
		this.utenteUltimaModifica = utenteUltimaModifica;
		this.dataUltimaModifica = dataUltimaModifica;
		this.dataInizioRecord = dataInizioRecord;
		this.dataFineRecord = dataFineRecord;
	}

	// CHILDREN
	@JsonProperty(access = Access.WRITE_ONLY)
	@JsonManagedReference("theDstatiAdesionePf")
	@OneToMany(mappedBy = "theDstatiAdesionePf", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
	@ToString.Exclude
	private Collection<DesitiRichAdesionePf> theDesitiRichAdesionePf = new ArrayList<>();

	// PARENTS

	// GETTER/SETTER
	/**
	 * @return the sequIdStatoAdesionePf
	 */
	public Long getSequIdStatoAdesionePf() {
		return this.sequIdStatoAdesionePf;
	}

	/**
	 * @param sequIdStatoAdesionePf to set
	 */
	public void setSequIdStatoAdesionePf(Long sequIdStatoAdesionePf) {
		this.sequIdStatoAdesionePf = sequIdStatoAdesionePf;
	}

	/**
	 * @return the codiStatoAdesione
	 */
	public String getCodiStatoAdesione() {
		return this.codiStatoAdesione;
	}

	/**
	 * @param codiStatoAdesione to set
	 */
	public void setCodiStatoAdesione(String codiStatoAdesione) {
		this.codiStatoAdesione = codiStatoAdesione;
	}

	/**
	 * @return the descStatoAdesione
	 */
	public String getDescStatoAdesione() {
		return this.descStatoAdesione;
	}

	/**
	 * @param descStatoAdesione to set
	 */
	public void setDescStatoAdesione(String descStatoAdesione) {
		this.descStatoAdesione = descStatoAdesione;
	}

	/**
	 * @return the flagEliminato
	 */
	public String getFlagEliminato() {
		return this.flagEliminato;
	}

	/**
	 * @param flagEliminato to set
	 */
	public void setFlagEliminato(String flagEliminato) {
		this.flagEliminato = flagEliminato;
	}

	/**
	 * @return the utenteUltimaModifica
	 */
	public String getUtenteUltimaModifica() {
		return this.utenteUltimaModifica;
	}

	/**
	 * @param utenteUltimaModifica to set
	 */
	public void setUtenteUltimaModifica(String utenteUltimaModifica) {
		this.utenteUltimaModifica = utenteUltimaModifica;
	}

	/**
	 * @return the dataUltimaModifica
	 */
	public Date getDataUltimaModifica() {
		return this.dataUltimaModifica;
	}

	/**
	 * @param dataUltimaModifica to set
	 */
	public void setDataUltimaModifica(Date dataUltimaModifica) {
		this.dataUltimaModifica = dataUltimaModifica;
	}

	/**
	 * @return the dataInizioRecord
	 */
	public Date getDataInizioRecord() {
		return this.dataInizioRecord;
	}

	/**
	 * @param dataInizioRecord to set
	 */
	public void setDataInizioRecord(Date dataInizioRecord) {
		this.dataInizioRecord = dataInizioRecord;
	}

	/**
	 * @return the dataFineRecord
	 */
	public Date getDataFineRecord() {
		return this.dataFineRecord;
	}

	/**
	 * @param dataFineRecord to set
	 */
	public void setDataFineRecord(Date dataFineRecord) {
		this.dataFineRecord = dataFineRecord;
	}

	// CHILD GETTER/SETTER
	/**
	 * @return the DesitiRichAdesionePf
	 */
	public Collection<DesitiRichAdesionePf> getTheDesitiRichAdesionePf() {
		return theDesitiRichAdesionePf;
	}

	/**
	 * @param aDesitiRichAdesionePfList to set
	 */
	public void setTheDesitiRichAdesionePf(Collection<DesitiRichAdesionePf> aDesitiRichAdesionePfList) {
		theDesitiRichAdesionePf = aDesitiRichAdesionePfList;
	}

	/// ADD CHILD
	public void addDesitiRichAdesionePf(DesitiRichAdesionePf desitiRichAdesionePf) {
		theDesitiRichAdesionePf.add(desitiRichAdesionePf);
	}

	// PARENT GETTER/SETTER

	// PARENT ID GETTER/SETTER

	// PARENT OBJECT TITLE

	// PARENT OBJECT KEY

	// IMPORTED PARENT OBJECT KEY

	// OPERATIONS

	// OBJECT KEY
	/**
	 * Restituisce l'identificativo della chiave in formato stringa. Ritorna
	 * conveniente nelle selezioni da lista.
	 * 
	 * @return L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public String getObjectKey() {
		return getObjectKeyById(getDstatiAdesionePfKey());
	}

	public String getObjectKeyById(DstatiAdesionePfKey identification) {
		if (identification == null) {
			return null;
		}
		StringBuilder output = new StringBuilder();
		return output.toString();
	}

	/**
	 * Inizializza la parte identificativa del bean in base alla stringa tokenizzata
	 * da "||" fornita in input.
	 * 
	 * @param key L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public void setObjectKey(String key) {
		if (key == null || key.trim().length() == 0) {
			return;
		}
		String[] array = StringUtils.splitByWholeSeparatorPreserveAllTokens(key, getRowIdFieldDelimiter());
		int ctr = 0;

		dstatiAdesionePfKey = new DstatiAdesionePfKey();
	}

	// OBJECT TITLE
	public String getObjectTitle() {
		StringBuilder output = new StringBuilder();
		output.append(getCodiStatoAdesione());
		return output.toString();
	}

	// COMPOSITE PRIMARY KEY
	@EmbeddedId
	private DstatiAdesionePfKey dstatiAdesionePfKey;

	// GETTER/SETTER CK
	/**
	 * @return the dstatiAdesionePfKey
	 */
	public DstatiAdesionePfKey getDstatiAdesionePfKey() {
		return this.dstatiAdesionePfKey;
	}

	/**
	 * @param dstatiAdesionePfKey to set
	 */
	public void setDstatiAdesionePfKey(DstatiAdesionePfKey dstatiAdesionePfKey) {
		this.dstatiAdesionePfKey = dstatiAdesionePfKey;
	}

	// COMPOSITE KEY CLASS

	// PREPERSIST
	public void syncCK() {
		if (dstatiAdesionePfKey == null) {
			dstatiAdesionePfKey = new DstatiAdesionePfKey();
		}
	}

	@PrePersist
	public void prePersist() {
		syncCK();
	}

	@PreUpdate
	public void PreUpdate() {
		syncCK();
	}

	// Equals / HashCode
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o))
			return false;
		DstatiAdesionePf that = (DstatiAdesionePf) o;
		return dstatiAdesionePfKey != null && Objects.equals(dstatiAdesionePfKey, that.dstatiAdesionePfKey);
	}

	@Override
	public int hashCode() {
		return Objects.hash(dstatiAdesionePfKey);
	}
}
